Show / Hide Table of Contents

# Struct Vector4

##### Implements

IEquatable<Vector4>
IFormattable

##### Inherited Members

System.Object.Equals(System.Object, System.Object)
System.Object.GetType()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: FFXIVClientStructs.FFXIV.Common.Math

###### Assembly: FFXIVClientStructs.dll

##### Syntax

    public struct Vector4

### Constructors

| Improve this Doc View Source

#### Vector4(Single)

##### Declaration

    public Vector4(float value)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | value |

| Improve this Doc View Source

#### Vector4(Single, Single, Single, Single)

##### Declaration

    public Vector4(float x, float y, float z, float w)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | x |
System.Single | y |
System.Single | z |
System.Single | w |

### Fields

| Improve this Doc View Source

#### NegativeInfinity

##### Declaration

    public static readonly Vector4 NegativeInfinity

##### Field Value

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### One

##### Declaration

    public static readonly Vector4 One

##### Field Value

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### PositiveInfinity

##### Declaration

    public static readonly Vector4 PositiveInfinity

##### Field Value

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### W

##### Declaration

    public float W

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### X

##### Declaration

    public float X

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Y

##### Declaration

    public float Y

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Z

##### Declaration

    public float Z

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Zero

##### Declaration

    public static readonly Vector4 Zero

##### Field Value

Type | Description
--- | ---
Vector4 |

### Properties

| Improve this Doc View Source

#### Magnitude

##### Declaration

    public readonly float Magnitude { get; }

##### Property Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### SqrMagnitude

##### Declaration

    public readonly float SqrMagnitude { get; }

##### Property Value

Type | Description
--- | ---
System.Single |

### Methods

| Improve this Doc View Source

#### Distance(Vector4, Vector4)

##### Declaration

    public static float Distance(Vector4 a, Vector4 b)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
Vector4 | b |

##### Returns

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Dot(Vector4, Vector4)

##### Declaration

    public static float Dot(Vector4 left, Vector4 right)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | left |
Vector4 | right |

##### Returns

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Equals(Vector4)

##### Declaration

    public bool Equals(Vector4 other)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | other |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Equals(Object)

##### Declaration

    public override bool Equals(object obj)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Object | obj |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

System.ValueType.Equals(System.Object)
| Improve this Doc View Source

#### GetHashCode()

##### Declaration

    public override int GetHashCode()

##### Returns

Type | Description
--- | ---
System.Int32 |

##### Overrides

System.ValueType.GetHashCode()
| Improve this Doc View Source

#### Lerp(Vector4, Vector4, Single)

##### Declaration

    public static Vector4 Lerp(Vector4 start, Vector4 end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | start |
Vector4 | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### LerpUnclamped(Vector4, Vector4, Single)

##### Declaration

    public static Vector4 LerpUnclamped(Vector4 start, Vector4 end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | start |
Vector4 | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Normalize(Vector4)

##### Declaration

    public static Vector4 Normalize(Vector4 value)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | value |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Project(Vector4, Vector4)

##### Declaration

    public static Vector4 Project(Vector4 left, Vector4 right)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | left |
Vector4 | right |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### SqrDistance(Vector4, Vector4)

##### Declaration

    public static float SqrDistance(Vector4 a, Vector4 b)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
Vector4 | b |

##### Returns

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### ToString()

##### Declaration

    public override string ToString()

##### Returns

Type | Description
--- | ---
System.String |

##### Overrides

System.ValueType.ToString()
| Improve this Doc View Source

#### ToString(String, Nullable<IFormatProvider>)

##### Declaration

    public string ToString(string format, IFormatProvider? formatProvider)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | format |
System.Nullable<IFormatProvider> | formatProvider |

##### Returns

Type | Description
--- | ---
System.String |

| Improve this Doc View Source

#### Transform(Vector2, Matrix4x4)

##### Declaration

    public static Vector4 Transform(Vector2 position, Matrix4x4 matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector2 | position |
Matrix4x4 | matrix |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Transform(Vector2, Quaternion)

##### Declaration

    public static Vector4 Transform(Vector2 value, Quaternion rotation)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector2 | value |
Quaternion | rotation |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Transform(Vector3, Matrix4x4)

##### Declaration

    public static Vector4 Transform(Vector3 position, Matrix4x4 matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector3 | position |
Matrix4x4 | matrix |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Transform(Vector3, Quaternion)

##### Declaration

    public static Vector4 Transform(Vector3 value, Quaternion rotation)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector3 | value |
Quaternion | rotation |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Transform(Vector4, Matrix4x4)

##### Declaration

    public static Vector4 Transform(Vector4 vector, Matrix4x4 matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | vector |
Matrix4x4 | matrix |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Transform(Vector4, Quaternion)

##### Declaration

    public static Vector4 Transform(Vector4 value, Quaternion rotation)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | value |
Quaternion | rotation |

##### Returns

Type | Description
--- | ---
Vector4 |

### Operators

| Improve this Doc View Source

#### Addition(Vector4, Vector4)

##### Declaration

    public static Vector4 operator +(Vector4 a, Vector4 b)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
Vector4 | b |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Division(Vector4, Single)

##### Declaration

    public static Vector4 operator /(Vector4 a, float d)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
System.Single | d |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Equality(Vector4, Vector4)

##### Declaration

    public static bool operator ==(Vector4 left, Vector4 right)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | left |
Vector4 | right |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Implicit(Vector4 to Vector4)

##### Declaration

    public static implicit operator Vector4(Vector4 v)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | v |

##### Returns

Type | Description
--- | ---
System.Numerics.Vector4 |

| Improve this Doc View Source

#### Implicit(Vector4 to Vector4)

##### Declaration

    public static implicit operator Vector4(Vector4 v)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Numerics.Vector4 | v |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Inequality(Vector4, Vector4)

##### Declaration

    public static bool operator !=(Vector4 left, Vector4 right)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | left |
Vector4 | right |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Multiply(Vector4, Single)

##### Declaration

    public static Vector4 operator *(Vector4 a, float d)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
System.Single | d |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Multiply(Single, Vector4)

##### Declaration

    public static Vector4 operator *(float d, Vector4 a)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | d |
Vector4 | a |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### Subtraction(Vector4, Vector4)

##### Declaration

    public static Vector4 operator -(Vector4 a, Vector4 b)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |
Vector4 | b |

##### Returns

Type | Description
--- | ---
Vector4 |

| Improve this Doc View Source

#### UnaryNegation(Vector4)

##### Declaration

    public static Vector4 operator -(Vector4 a)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector4 | a |

##### Returns

Type | Description
--- | ---
Vector4 |

### Implements

IEquatable<>
IFormattable